import matplotlib.pyplot as plt
import numpy as np
import urllib.request




def meteo_choix(choix_utilisateur):    #par heures sur la zone géographique concerné
    lines = urllib.request.urlopen('https://vhelio.org/wp-content/uploads/2021/09/meteo_finale.csv').readlines()
    
    H1a=[]
    H1b=[]
    H1c=[]
    H2a=[]
    H2b=[]
    H2c=[]
    H2d=[]
    H3=[]
    
    del lines[0]
    del lines[0]
    del lines[8761]
    del lines[8760]#suppression des ';' en fin de csv
    for line in lines:
       
    
        
        line = line.split(';')
        line[0]=line[0].rstrip(';')
         
        H1a.append(float(line[0]))
        H1b.append(float(line[1]))
        H1c.append(float(line[2]))
        H2a.append(float(line[3]))
        H2b.append(float(line[4]))
        H2c.append(float(line[5]))
        H2d.append(float(line[6]))
        H3.append(float(line[7]))
        
        del line[8]
        del line[9]
        del line[10]
    if choix_utilisateur=='h1a':
        return H1a
    if choix_utilisateur=='h1b':
        return H1b
    if choix_utilisateur=='h1c':
        return H1c
    if choix_utilisateur=='h2a':
        return H2a
    if choix_utilisateur=='h2b':
        return H2b
    
    if choix_utilisateur=='h2c':
            return H2c
    if choix_utilisateur=='h2d':
        return H2d
    if choix_utilisateur=='h3':
        return H3
    return 'erreur dans la saisie de la composante de la région'
    
    
    
   




def liste_annee_function(donnee_annee):#permet de séparer les 8760 données soit 365 jours avec 24 données + le jour de la semine (lundi,mardi,etc)
    annee=[]
    jour=[]
    l=0
    heure_aller=8
    heure_retour=16
    heure_promenade_week_end=10
    semaine=['lundi','mardi','mercredi','jeudi','vendredi','samedi','dimanche']
    for i in range (len(donnee_annee)):
     
        if i==0:
             jour.append([donnee_annee[i],0])
             continue
        else:           
           
            if i%24==0:#permet de diviser les données par pack de 24 (soit un jour)
                
                jour.append(semaine[l])
                if jour[-1]=='dimanche' or jour[-1]=='samedi' :
                    jour[heure_promenade_week_end][1]=2# pour le week end on suspose une balade qui dure la distance moyenne journalière 
                else:
                    jour[heure_aller-1][1]=1#le vhelio sera utiiser a cette heure là
                    jour[heure_retour-1][1]=1
                annee.append(jour)
                jour=[]
                jour.append([donnee_annee[i],0])
                if l==6:
                    l=0
                else:
                    l=l+1
                continue
            
            jour.append([donnee_annee[i],0])
    annee.append(jour)
    return annee

def Capacite_batt_dans_le_temps(liste_annee,conso_WH_par_km, capacite_batt,distance_moyenne):
    rendement_panneau=0.15
    surface_panneau=1
    capacite_batt_reel=capacite_batt
   
    compteur_de_charges=0
    liste_finale=[]
    prix_moyen_kwh=0.192
    
    
    electricite_utilise_par_le_moteur=0
    for jours in range(len( liste_annee)):
       
        for heures in range(len(liste_annee[jours])-1):
        
            infos=liste_annee[jours][heures]
            
           # la capacité de la batterie varie selon ce que le panneaux fournit et la consommation éléctrique pendant l'utilisation du vhélio
            electricite_utilise_par_le_moteur= electricite_utilise_par_le_moteur+infos[1]*conso_WH_par_km*distance_moyenne/2
            
            capacite_batt_reel=capacite_batt_reel+ infos[0]*rendement_panneau*surface_panneau*1-infos[1]*conso_WH_par_km*distance_moyenne/2
            
           
            if capacite_batt_reel>capacite_batt:
            
                capacite_batt_reel=capacite_batt
            if capacite_batt_reel<=0:
                capacite_batt_reel=capacite_batt
                compteur_de_charges=compteur_de_charges+1
                
            
            infos.append(capacite_batt_reel)
            liste_finale.append(capacite_batt_reel/capacite_batt*100)
    return liste_finale,liste_annee,compteur_de_charges,compteur_de_charges*(capacite_batt/1000)*prix_moyen_kwh, electricite_utilise_par_le_moteur

def consommation_wh_par_km_estimation (denivele,poids):
    #Après les expèriences faites on arrive sur une moyenne de 16 sur du plat et 25 en montée (c'estdonnées seront mise à jour avec les nouveaux tests du vhélio 4)
    composante_poids=0
    composante_poids=(4/200)*poids# approche linéaire 
    if poids>=200:
        composante_poids=4
    if poids<=0:
        composante_poids=0
   
        
    if denivele==0:
        return 14+composante_poids
    if denivele>500:
        return 21+composante_poids#21 est une moyenne entre la consommation en montée et la consommation en descente sur une distance moyenne
    return 14+(7/500)*denivele+composante_poids# approximation linéaire de la consommation éléctrique 

def fonction_fianale(capacite_battrie_desiree,distance_moyenne_jour,denivele,poids,liste_ensolleillement_annee):
   #cette fonction utilise toute les fonctions définis avant et permet l'affichage
    
    liste_ensolleillement_finale=liste_annee_function(liste_ensolleillement_annee)
    liste_finale,liste_annee,compteur_de_charges,prix_annee,electricite_conso=Capacite_batt_dans_le_temps(liste_ensolleillement_finale,consommation_wh_par_km_estimation(denivele,poids),capacite_battrie_desiree,distance_moyenne_jour)
    couverture_solaire=round(100*(electricite_conso-(compteur_de_charges+1)*capacite_battrie_desiree)/electricite_conso)
    abs=np.linspace(0,8758,8759)
    xlabels = ["Janvier", "Février", "Mars", "Avril", "Mai", "Juin","Juillet","Aout", "Septembre", "octobre", "Novembre", "Décembre"]

    ord=liste_finale
    70
    plt.plot(abs,ord)
    plt.xlabel("            ------|------------été--------------|---------------")
    plt.ylabel('%')
    plt.title("                   Pourcentage de charge dans  la batterie en fonction des heures de l'année  " )
      
    
    plt.show()
    
    print('il faudra recharger le vhelio sur secteur environ',compteur_de_charges,"fois sur l'annee")
    print("cela coutera" ,round(prix_annee,2),"€ sur l'annee")
    print("la couverture solaire du vhelio est de",couverture_solaire,'%')
    
    
#%%
   
print('Quelle capacite de batterie envisagez vous?\n(exemple: tapez" "700")' )
capacite_battrie_desiree=float(input())
print('Combien de kilometres fait vous chaque jour\n(exemple: tapez "10")')
distance_moyenne_jour=float(input())
print('Quel est le denivele moyen de votre trajet journalier (en metres).\nPour indication: "0" signifie  que le trajet se fait sur du plat, "100"m :legerement vallonne, "200": plutot vallonne, "300": vallonne, "500": montagneux, (exemple: tapez "100")')
denivele=float(input())
print("Quel est le poids embarque en plus du conducteur (bagages + passagers).\n(exemple: un passagers de 80kg+50kg de chargement soit 130 kg.\nIl faut taper 130 dans le simulateur.)\n")
poids=(float(input()))
print("Veuillez rentrer votre zone climatique en miniscule.\nElle est indiquer sur la carte de france ci-dessus\n(exemple: taper h1a ou h2c) surtout ecrire les 3 caracteres en minuscules.")
zone_climatique=input()



liste_ensolleillement_annee=meteo_choix(zone_climatique)
fonction_fianale(capacite_battrie_desiree,distance_moyenne_jour,denivele,poids,liste_ensolleillement_annee)
# .Le projet Vhélio est libre et collaboratif. Cette version du simulateur est une première version largement améliorable. N'hésitez pas à vous inscrire en tant que faiseur pour nous aider à l'améliorer.
# Lien :   https://www.helloasso.com/associations/velo-solaire-pour-tous/adhesions/adhesion-a-l-association-velo-solaire-pour-tous-faiseur